using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using iPackage.Core.Web;
using iPackage.Core.Web.Extensions;
using iPackage.Core.Web.Models.Entity;
using iPackage.Core.Web.WebFramework.Configurations;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.HttpsPolicy;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.Hosting;

namespace NugetTest.AspCore
{
    public class Startup : iPackageStartup<Startup>
    {
        public Startup(Microsoft.AspNetCore.Hosting.IHostingEnvironment env) : base(env)
        {

        }

        public override void ConfigureServices(IServiceCollection services)
        {
            base.ConfigureServices(services);

            services.AddiPackageDbContext<ApplicationIdentityContext,Startup>(options =>
            {
                options.UseProjectAssembly(typeof(Startup).Assembly);
                options.UseSqlServer(Configuration.GetConnectionString("LocalConnection"),
                    b => b.MigrationsAssembly("NugetTest.AspCore"));
            });
        }
    }
}
