﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;
using iPackage.Models.Dto;
using iPackage.Models.Entity;
using iPackage.Models.Service;
using iPackage.Models.Util;

namespace iPackage.Core.Web.Services.Contracts
{
    public interface IReportService : IScopedDependency
    {
        Task<ReportResult> CrudDataBaseReportTask<T>(ReportRequest request) where T : ApiEntity;

        Task<ReportResult> CrudDataBaseDtoReportTask<T, TDto>(ReportRequest request)
            where T : ApiEntity, new()
            where TDto : BaseDto<TDto, T>, new();
    }
}
